//
//  VolumeView.m
//  AnalogSynthesizer
//
//  Created by 成田 拓郎 on 10/05/24.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "VolumeView.h"


@implementation VolumeView

@synthesize imageKnob;
@synthesize valueKnob;
@synthesize valueMax;

- (id)initWithFrame:(CGRect)frame {
    if ((self = [super initWithFrame:frame])) {
        // Initialization code
    }
    return self;
}

- (id)initWithCoder:(NSCoder *)aDecoder {
	if ((self = [super initWithCoder:aDecoder])) {
		self.imageKnob = [UIImage imageNamed:@"VolumeKnob.png"];
		self.valueKnob = 0;
		self.valueMax = 127;
	}
	return self;
}

// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
	rect = CGRectMake(0, 0, self.bounds.size.width, self.bounds.size.height);
	[imageKnob drawInRect:rect];
}

- (void)rotateView {
	CGAffineTransform trans = CGAffineTransformIdentity;
	CGFloat rad = (M_PI / 4.0f) + ((M_PI * 1.5f * valueKnob) / valueMax);
	self.transform = CGAffineTransformRotate(trans, rad);
}

- (void)rotation:(CGFloat)y {
	CGFloat z = valueMax / 128.0f;
	if (z < 0.1f) z = 0.1f;
	UInt32 v = (UInt32)(beginValue + (beginY - y) * z + 0.5f);

	if (v < 0)
		v = 0;
	else if (v > valueMax)
		v = valueMax;

	self.valueKnob = v;
	[self rotateView];
}

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
	UITouch* touch = [touches anyObject];
	beginValue = self.valueKnob;
	CGPoint p = [touch locationInView:self.superview];
	beginY = p.y;
}

- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event {
	UITouch* touch = [touches anyObject];
	CGPoint p = [touch locationInView:self.superview];
	[self rotation:p.y];
	
	(void)[target performSelector:action withObject:self];
}

- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {
	UITouch* touch = [touches anyObject];
	CGPoint p = [touch locationInView:self.superview];
	[self rotation:p.y];
	
	(void)[target performSelector:action withObject:self];
}

- (void)dealloc {
	[imageKnob release];
    [super dealloc];
}

- (void)setAction:(SEL)aSelector {
	action = aSelector;
}

- (void)setTarget:(id)anObject {
	target = anObject;
}

@end
